/*
 * PB-Lib C/C++ Library Version 0.021
 *
 * Copyright (C) 1995 by Branislav L. Slantchev
 * A product of Silicon Creations, Inc.
 *
 * See the file "copying.pbl" for licensing information.
*/

#ifndef __PBNAMES_H
#define __PBNAMES_H

/*
 * ProBoard-specific files (_PBDEFS.H)
*/
#define fnAKA        "AKA.PRO"        /* primary net address and AKAs     */
#define fnBINLOG     "BINLOG.PB"      /* binary log of the BBS usage      */
#define fnCONFIG     "CONFIG.PRO"     /* ProBoard main configuration file */
#define fnEVENTS     "EVENTS.PRO"     /* events database                  */
#define fnFLAGDESC   "FLAGDESC.PB"    /* flag descriptions (text)         */
#define fnLIMITS     "LIMITS.PRO"     /* user IDs and limits              */
#define fnMODEM      "MODEM.PB"       /* modem configuration file         */
#define fnONLINE     "ONLINE.PRO"     /* info about the user online       */
#define fnPROTOCOL   "PROTOCOL.PRO"   /* external protocol definitions    */
#define fnPVTFILES   "PVTFILES.PB"    /* private files database           */
#define fnTEMPLATE   "TEMPLATE.PB"    /* templates for the validation     */
#define fnTIMELOG    "TIMELOG.PRO"    /* BBS usage log, somewhat obsolete */
#define fnNODEIDX    "NODE_IDX.PRO"   /* nodelist index                   */
#define fnTOPS       "TOPS.PB"        /* top users, see _PBDEFS.H         */
#define fnDEFLANG    "DEFLANG.PB"     /* the default language file        */
#define fnLANGEXT    ".PBL"           /* the extension for language files */
#define fnMENUEXT    ".PBM"           /* the extension for menu files     */

/*
 * Filebase data files (_PBDEFS.H)
*/
#define fnFGROUPS    "FGROUPS.PB"     /* file groups definitions          */
#define fnFILECFG    "FILECFG.PRO"    /* file areas definitions           */
#define fnFILESIDX   "FILESIDX.PB"    /* filebase index file              */

/*
 * Userbase data files (_PBDEFS.H and _RADEFS.H)
*/
#define fnUSERS      "USERS.BBS"      /* RA-compatible user data file     */
#define fnUSERSIDX   "USERSIDX.BBS"   /* RA-compatible index to USERS/PB  */
#define fnUSERSPB    "USERSPB.BBS"    /* PB addition to USERS.BBS         */
#define fnUSERSXI    "USERSXI.BBS"    /* RA-compatible, empty records     */

/*
 * Messagebase configuration files (_PBDEFS.H)
*/
#define fnMESSAGES   "MESSAGES.PB"    /* message areas definitions        */
#define fnMGROUPS    "MGROUPS.PB"     /* message groups definitions       */

/*
 * Hudson messagebase files (__MSGHMB.H)
*/
#define fnLASTREAD   "LASTREAD.BBS"   /* user last read mesg per area     */
#define fnMSGHDR     "MSGHDR.BBS"     /* detailed message headers         */
#define fnMSGIDX     "MSGIDX.BBS"     /* index for searching the base     */
#define fnMSGINFO    "MSGINFO.BBS"    /* info about the whole mesgbase    */
#define fnMSGTOIDX   "MSGTOIDX.BBS"   /* for mail-box checks for user     */
#define fnMSGTXT     "MSGTXT.BBS"     /* actual message text              */

/*
 * these files have no defined structures in PBLib
*/
#define fnTRASHCAN   "TRASHCAN.CTL"   /* text file, one name per line     */
#define fnCOST       "COST.PRO"       /* netmail cost definition file     */
#define fnUPLOADLOG  "UPLOAD.LOG"     /* uploads log file                 */
#define fnDNLOADLOG  "DOWNLOAD.LOG"   /* downloads log file               */

#endif
